=== debian/changelog ===
cmake (3.13.2-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild fro stretch-backports .

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 04 Jan 2019 15:17:26 +0100

cmake (3.13.2-1) unstable; urgency=medium

  * New upstream release.
    - No longer passes implicit include directories to the moc tool,
      fixing kio FTBFS. (Closes: #915391)

 -- Felix Geyer <fgeyer@debian.org>  Fri, 14 Dec 2018 19:07:46 +0100
