## cmake 3.13.4

=== debian/changelog ===
cmake (3.13.4-1.lnd.2) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 10:57:03 +0800

cmake (3.13.4-1.lnd.1) unstable; urgency=medium

  * Add support loongarch64

 -- Liu Xiang <liuxiang@loongson.cn>  Thu, 17 Dec 2020 20:58:37 +0800

cmake (3.13.4-1) unstable; urgency=medium

  * New upstream release.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 10 Feb 2019 11:33:12 +0100
